'use strict';
const fs = require('fs')
const path = require('path')
const util = require('util')
const exec = util.promisify(require('child_process').exec)

const vips = `./soft/libs/vips/linux/vips`
const vipsheader = `./soft/libs/vips/linux/vipsheader`

async function asyncExec(cmd) {
    let result = await exec(cmd)
    return result.stdout
}

async function getImageInfo(filename) {
    let cmd = `"${vipsheader}" -a '${filename}'`
    if (process.platform === 'win32') {
        cmd = `"${vipsheader}" -a "${filename}"`
    }

    let json = {}
    try {
        let result = await asyncExec(cmd)
        let arr = result.trim().split('\n')
        for (let item of arr) {
            if (item.match(/^@/)) {
                json['@'] = json['@'] || []
                json['@'].push(item)
            }
            else if (!item.trim()) {
            }
            else if (!item.includes(':')) {
            }
            else {
                let [key, value] = item.split(':')
                try {
                    json[key] = value.trim()
                }
                catch (e) {
                    console.log(16, e)
                    console.log(17, arr)
                    json[key] = value
                }
            }
        }

        let type = ''
        if (json['vips-loader']) {
            type = json['vips-loader']
            type = type.replace('load_source', '').trim()
            type = type.replace('load', '').trim()
        }
        else {
            type = path.extname(filename).slice(1).toLowerCase()
        }
        json.type = type
    }
    catch (e) {
        console.error(e)
        json = { type: 'not_img' }
    }

    return json
}

module.exports = getImageInfo